{%- import "rda_dmp_cs/_contributor_contact.j2" as contributor with context -%}
{%- import "rda_dmp_cs/_dataset.j2" as dataset with context -%}
{%- import "rda_dmp_cs/_utils.j2" as utils with context -%}

{#- ----------------------------------------------------------------------- -#}
{#-  GLOBAL VARIABLES                                                       -#}
{#- ----------------------------------------------------------------------- -#}

{#- this global namespace stack will be used to exlusively store stuff -#}
{#- to help us monitor the sequence of annotations as they appear  -#}
{#- and the paths traversed  -#}

{#- ------------------------------------------------------------  -#}
{#- globals to THIS file, which we call locals... -#}
{#- ------------------------------------------------------------  -#}
{#- variables global to this file, not meant to be used by the caller  -#}

{%- set local_ns = namespace(description="itemList paths, annotations") -%}

{%- set local_ns.annotations_encountered_stack = [] -%}

{#- ------------------------------------------------------------  -#}
{#- end of globals  -#}
{#- ------------------------------------------------------------  -#}

{#- note:   -#}
{#- we'll be using item_list_paths_stack later down the track -#}
{#- if required.... -#}


{%- macro trackItemListStart()  -%}
  {%- do local_ns.annotations_encountered_stack.append([]) -%}
{%- endmacro  -%}

{%- macro trackPathStart(globals, path)  -%}
  {%- set rolling_depth =  globals.global_ns.paths.rolling_depth -%}
  {%- set rolling_depth = rolling_depth + 1 -%}
  {%- do globals.global_ns.paths.update({ "rolling_depth" : rolling_depth }) -%}

  {{ utils.deepCopy(globals.global_ns.paths.item) }}
  {%- set item = utils.global_ns.var_stack.pop() -%}
  {%- do item.update({ "path" : path })  -%}
  {%- do item.update({ "depth" : rolling_depth })  -%}
  {%- do globals.global_ns.paths.stack.append(item) -%}
{%- endmacro  -%}

{%- macro trackOptionPathStart(globals, path)  -%}
  {{ trackPathStart(globals, path) }}
  {%- set item = globals.global_ns.paths.stack|last -%}
  {%- do item.update({ "option" : true })-%}
{%- endmacro  -%}

{%- macro trackItemPathStart(globals, path)  -%}
  {{ trackPathStart(globals, path) }}
  {%- set item = globals.global_ns.paths.stack|last -%}
  {%- do item.update({ "item" : true })-%}
{%- endmacro  -%}

{%- macro trackPathEnd(globals)  -%}
  {%- set rolling_depth =  globals.global_ns.paths.rolling_depth -%}
  {%- set rolling_depth = rolling_depth - 1 -%}
  {%- do globals.global_ns.paths.update({ "rolling_depth" : rolling_depth }) -%}

  {%- do globals.global_ns.paths.stack.pop() -%}
{%- endmacro  -%}


{%- macro trackAnnotation(annotation)  -%}
{#- note: we only track action annotations -#}
{#- Q: does it make sense? -#}
  {%- set size = local_ns.annotations_encountered_stack|length  -%}
  {%- do local_ns.annotations_encountered_stack[size - 1].append(annotation) -%}
{%- endmacro  -%}


{#- complete dataset creation  is denoted by the following annotation -#}
{%- set local_ns.dataset_creation_annotation = "RDADataset" -%}


{%- macro completeDatasetItemList(globals, dmp_being_built) -%}
  {%- set last_annotations = local_ns.annotations_encountered_stack.pop() -%}
  {%- if last_annotations -%}
    {#- we need only check if the creation annotation is present  -#}
    {%- if local_ns.dataset_creation_annotation in last_annotations  -%}
      {{ dataset.doLastSetOfDatasetClones(globals, dmp_being_built) }}
    {%- endif -%}
  {%- endif -%}
{%- endmacro  -%}


{%- macro processItemListEnd(globals, dmp_being_built) -%}
  {{ completeDatasetItemList(globals, dmp_being_built) }}
{%- endmacro  -%}
